#include <stderror.mqh>
#include <stdlib.mqh>

#include <WinUser32.mqh>
#include <Predictor.MT.mqh>
#include <criticalsection.mqh>

//---- input parameters
extern int Expert_ID = 1600;

int MagicNumber = 0;
extern int sPeriod=15;
extern int periodTrendExtractionS = 2;
extern int periodTrendPredictionS = 6;
extern int numberTrainingRowsS = 20;
extern bool amplitudeMethodS = 0;
extern double cmS = 0;
extern int multiplicator = 3;

extern int periodTrendExtractionL = 2;
extern int periodTrendPredictionL = 6;
extern int numberTrainingRowsL = 20;
extern bool amplitudeMethodL = 0;
extern double cmL = 0;

int displacementL = 1;
extern int displacementS = 4;
int discretizationIntervalL = 1;
extern int discretizationIntervalS = 1;

extern double lotsInit = 0.01;

int NumberOfTries = 6;

int profitableLongPeriods = 0;

double lastSR = 0;
int numSR = 0;
double meanSR = 0;

int numLPBars = 1;

double lots = 1;

//extern bool pokrokovyjOrder=true;

int denVidkryttiaOrderivP=1;
int denVidkryttiaOrderivK=4;
extern int denZakryttiaOrderiv=5;

extern int hodynaZakryttiaOrderiv=16;
extern int hodynaVidkryttiaOrderivP=4;
extern int hodynaVidkryttiaOrderivK=16;

//extern int hodynaObrobkyVidkrytyxOrderiv=4;

int prevtime = 0;
int nextTimeNode = 0;

static int BUY=1;
static int WAIT=0;
static int SELL=-1;

extern double KL=6;
extern double KP=5;

double riskCapital = 1000; // Amount in currency units
double gainCapital = 1000; // Amount in currency units

double longRecommendationContinued = 0;

double longRecommendation = 0;
double shortRecommendation = 0;

extern bool useStopLoss = true;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
    int Period_ID = 0;
    switch ( Period() )
    {
        case PERIOD_MN1: Period_ID = 9; break;
        case PERIOD_W1:  Period_ID = 8; break;
        case PERIOD_D1:  Period_ID = 7; break;
        case PERIOD_H4:  Period_ID = 6; break;
        case PERIOD_H1:  Period_ID = 5; break;
        case PERIOD_M30: Period_ID = 4; break;
        case PERIOD_M15: Period_ID = 3; break;
        case PERIOD_M5:  Period_ID = 2; break;
        case PERIOD_M1:  Period_ID = 1; break;
    }
    MagicNumber = Expert_ID * 10 + Period_ID;

	if(KL == -1)
	{
		riskCapital = 0;
		useStopLoss = false;
	}
	else
	{
		riskCapital = KL;
		useStopLoss = true;
	}

	if(KP == -1)
		gainCapital = 0;
	else
	{
		gainCapital = KP;
	}
	// reset lot calculation
	lots = lotsInit;
	MyUnlock("Predictor");
	return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
	//----
	return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

void ErrorHandler()
{
	int error=GetLastError();
	if(error != 0)
	{
		Print("error(",error,"): ",ErrorDescription(error));

	}
}

int MyLock(string lockName)
{
	return (0);
	return (Lock(lockName));
}

int MyUnlock(string lockName)
{
	return (0);
	return (Unlock(lockName));
}

void LockErrorHandler(int lockError)
{
	if(lockError != 0)
	{
		if(lockError == LOCK_FAILURE)
		{
			Print("lock error: LOCK_FAILURE");
		}
		else if (lockError == LOCK_EXPERT_STOPPED)
		{
			Print("lock error: LOCK_EXPERT_STOPPED");
		}
		else if (lockError == LOCK_TIMEOUT)
		{
			Print("lock error: LOCK_TIMEOUT");      
		}
	}		
}

void ClosePosBySelect(double lots=-1, int slippage=7) 
{
	bool   fc = false;
	color  clClose;
	double ll, pa, pb, pp;
	int    err, it;
	Print("##############ClosePosBySelect");
	string sy=OrderSymbol();
	int orderType=OrderType();
	int mn=OrderMagicNumber();

	if (orderType==OP_BUY || orderType==OP_SELL) 
	{
		for (it=1; (it<=NumberOfTries) && (fc == false); it++) {
			if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
			while (!IsTradeAllowed()) 
			{
				Sleep(5000);
			}
			RefreshRates();
			//pa=MarketInfo(OrderSymbol(), MODE_ASK);
			//pb=MarketInfo(OrderSymbol(), MODE_BID);
			pa = Ask;      
			pb = Bid;

			if (orderType==OP_BUY) 
			{
				pp=pb; clClose=White;
			} else {
				pp=pa; clClose=White;
			}
			if(lots == -1)
			{
				ll=OrderLots();
			}
			else
			{
				ll=lots;
			}  
			fc=OrderClose(OrderTicket(), ll, pp, slippage, clClose);
			if(fc == false)
			{
				err=GetLastError();
				if (err==146)
				{
					while (IsTradeContextBusy()) 
						Sleep(1000*11);
				}
				if (err==128 || err==142 || err==143) 
				{
					Sleep(1000*66);
					// done, if order does not exist
					if (!ExistPositions(sy, orderType, mn)) 
					{
						break;
					}
					Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
					continue;
				}        
				if(err != 0)
				{
					Print("Error(",err,") Close ",GetNameOP(OrderType())," ",
						ErrorDescription(err),", try ",it);
					Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
					Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
						"  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
					Sleep(1000*5);
				}
			}

		}
	} else Print("Invalid operation. Close ",GetNameOP(OrderType()));
}

bool PositionCloseBy( int ticket, int opposite, color Color=CLR_NONE) 
{
	bool   fc = false;
	int it=0, err=0;

	for (it=1; (it<=NumberOfTries) && (fc == false); it++) {
		if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
		while (!IsTradeAllowed()) 
		{
			Sleep(5000);
		}
		//RefreshRates();
		Print("############PositionCloseBy");

		fc = OrderCloseBy(ticket, opposite, Color);
		if(fc == false)
		{
			err=GetLastError();
			if (err==146)
			{
				while (IsTradeContextBusy()) 
				{
					Sleep(1000*11);
				}
			}
		}
	}    
} 

bool ExistPositions(string sy="", int op=-1, int magic=-1) 
{
	int i, k=OrdersTotal();

	if (sy=="0") sy=Symbol();
	for (i=0; i<k; i++) 
	{
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
		{
			if (OrderSymbol()==sy || sy=="") 
			{
				if (OrderType()==OP_BUY || OrderType()==OP_SELL) 
				{
					if (op<0 || OrderType()==op) 
					{
						if (magic<0 || OrderMagicNumber()==magic) return(True);
					}
				}
			}
		}
	}
	return(False);
}

string GetNameTF(int TimeFrame=0) {
	if (TimeFrame==0) TimeFrame=Period();
	switch (TimeFrame) {
	case PERIOD_M1:  return("M1");
	case PERIOD_M5:  return("M5");
	case PERIOD_M15: return("M15");
	case PERIOD_M30: return("M30");
	case PERIOD_H1:  return("H1");
	case PERIOD_H4:  return("H4");
	case PERIOD_D1:  return("Daily");
	case PERIOD_W1:  return("Weekly");
	case PERIOD_MN1: return("Monthly");
	default:         return("UnknownPeriod");
	}
}

string GetNameOP(int op) {
	switch (op) {
	case OP_BUY      : return("Buy");
	case OP_SELL     : return("Sell");
	case OP_BUYLIMIT : return("Buy Limit");
	case OP_SELLLIMIT: return("Sell Limit");
	case OP_BUYSTOP  : return("Buy Stop");
	case OP_SELLSTOP : return("Sell Stop");
	default          : return("Unknown Operation");
	}
}

int OpenPosition(string symbol, int cmd, double volume, double stoploss, double takeprofit, int magic, int NumberOfTry=1, int slippage=7, color clOpen=CLR_NONE) 
{
	double price, pAsk, pBid;
	int    dg, err, it, stoplevel, ticket;
	string lsComm=WindowExpertName()+" "+GetNameTF(Period());

	if (symbol=="" || symbol=="0") symbol=Symbol();


	for (it=1; it<=NumberOfTries; it++) 
	{
		if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;

		while (!IsTradeAllowed())
		{
			Sleep(5000);
		}
		RefreshRates();
		dg=MarketInfo(symbol, MODE_DIGITS);
		//pAsk=MarketInfo(symbol, MODE_ASK);
		//pBid=MarketInfo(symbol, MODE_BID);
		pAsk = Ask;
		pBid = Bid;

		stoplevel = MarketInfo(symbol, MODE_STOPLEVEL)*Point;

		if (cmd==OP_BUY)
		{
			price=pAsk;
		}
		else
		{
			price=pBid;
		}
		price=NormalizeDouble(price, dg);
		Print("Volume: ", volume, " Price: ", price, " Stoploss: ", stoploss, " TakeProfit: ", takeprofit);

		bool invalidStops = false;    
		// check stops
		if (cmd==OP_BUY)
		{
			if((stoploss != 0) && ((price + (stoplevel)) < stoploss))
			{
				invalidStops = true;
			}
			if((takeprofit != 0) && ((price + (stoplevel)) > takeprofit))
			{
				invalidStops = true;
			}      
			if(stoploss < 0)
			{
				invalidStops = true;
			}    
		}

		if (cmd==OP_SELL)
		{
			if((stoploss != 0) && ((price - (stoplevel)) > stoploss))
			{
				invalidStops = true;
			}
			if((takeprofit != 0) && ((price - (stoplevel)) < takeprofit))
			{
				invalidStops = true;
			}  
			if(takeprofit < 0)
			{
				takeprofit = 0;
			}    
		}

		stoploss = NormalizeDouble(stoploss, dg);

		if(invalidStops)
		{
			Print("Eror invalid stops: price=", price, " stoploss=", stoploss, " takeprofit=", takeprofit);
			return (-1);
		}

		ticket=OrderSend(symbol, cmd, volume, price, slippage, stoploss, takeprofit, lsComm, magic, 0, clOpen);
		if (ticket>0) 
		{
			//if (UseSound) PlaySound(NameFileSound); 
			break;
		} 
		else 
		{
			err=GetLastError();
			if (err==128 || err==142 || err==143) {
				Sleep(1000*75);
				if (ExistPositions(symbol, cmd, magic)) {
					//if (UseSound) PlaySound(NameFileSound); 
					break;
				}
			}
			// ????? ????????? ?? ??????
			Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
			Print("Ask=",pAsk," Bid=",pBid," symbol=",symbol," volume=",volume," op=",GetNameOP(cmd),
				" price=",price," stoploss=",stoploss," takeprofit=",takeprofit," magic=",magic);
			if (pAsk==0 && pBid==0) Alert("Is "+symbol+" present in market overview?");
			// change lot size and try again with initial lot
			if(err == ERR_INVALID_STOPS)
			{
				return (ticket);
			}

			if(err ==ERR_NOT_ENOUGH_MONEY)
			{
				volume = lotsInit;
				continue;
			}

			if (err==ERR_COMMON_ERROR || err==ERR_ACCOUNT_DISABLED || err==ERR_INVALID_ACCOUNT || err==ERR_TRADE_DISABLED) 
			{
				return (ticket);
			}
			if (err==ERR_SERVER_BUSY || err==ERR_INVALID_TRADE_VOLUME || err==ERR_MARKET_CLOSED) {
				Sleep(1000*300); break;
			}
			if (err==ERR_LONG_POSITIONS_ONLY_ALLOWED || err==ERR_TRADE_TOO_MANY_ORDERS || err==4110 || err==4111)
			{
				return (ticket);
			}
			if (err==141) Sleep(1000*100);
			if (err==145) Sleep(1000*10);
			if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
			if (err!=135) Sleep(1000*10);
		}
	}
	return (ticket);
}

double StopLossSize(int cmd, double lots, double openPrice, double maxRisk)
{
	double stopLossSize = 0;

	if(!useStopLoss)
	{
		return (0);
	}
	string symbol = Symbol();

	// first currency name
	string first   =StringSubstr(symbol,0,3);         
	// second currency name
	string second  =StringSubstr(symbol,3,3);         
	// account currency
	string currency=AccountCurrency();                

	int ls = MarketInfo(Symbol(), MODE_LOTSIZE);
	double spread = (Ask-Bid)*(lots*ls);
	//Print("StopLossSize: Lot size: ", ls, " Maxrisk: ", maxRisk, " lots: ", lots, " openPrice: ", openPrice, " spread:", spread);

	stopLossSize = (maxRisk  + spread + lots*openPrice*ls)/(lots*ls)-(openPrice);
	//stopLossSize = (maxRisk -spread + lots*openPrice)/(lots*ls);

	double stopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
	if((stopLossSize < stopLevel) && (stopLossSize != 0))
	{
		stopLossSize = stopLevel;
	}


	if((stopLossSize < stopLevel) && (stopLossSize != 0))
	{
		stopLossSize = stopLevel;
	}

	//Print("Stop loss price level: ", stopLossSize, " Stops:", stopLevel );

	return (stopLossSize);
}

double TakeProfitSize(int cmd, double lots, double openPrice, double maxGain)
{
	double takeProfitSize = 0;

	string symbol = Symbol();

	// first currency name
	string first   =StringSubstr(symbol,0,3);         
	// second currency name
	string second  =StringSubstr(symbol,3,3);         
	// account currency
	string currency=AccountCurrency();                

	int ls = MarketInfo(Symbol(), MODE_LOTSIZE);
	double spread = (Ask-Bid)*(lots*ls);
	//Print("TakeProfitSize: Lot size: ", ls, " Maxgain: ", maxGain, " lots: ", lots, " openPrice: ", openPrice, " spread:", spread);

	//takeProfitSize = (maxGain + spread + lots*openPrice*ls)/(lots*ls)-openPrice;
	takeProfitSize = (maxGain +  lots*openPrice*ls)/(lots*ls)-openPrice;

	double stopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;

	if((takeProfitSize < stopLevel) && (takeProfitSize != 0))
	{
		takeProfitSize = stopLevel;
		Print("TAKEPROFIT: resetting to minimum value");

	}

	//Print("Take profit price level: ", takeProfitSize, " Stops: ", stopLevel);

	return (takeProfitSize);
}

int prevChartPeriod=0;

int start()
{
	int i=0;
	int prevticket=0;
	double slVal = 0;
	double tpVal = 0;
	double takeProfitBuy=0;
	double takeProfitSell=0;
	double slBuy=0;
	double slSell=0;
	double currentLots = 0;
	if((prevtime) == (Time[0]))
	{
		return (0);
	}
	prevtime = Time[0];

   double array1[][6];
   ArrayCopyRates(array1, NULL, sPeriod);
   
   if(array1[0][0] != iTime(NULL,0,i)) 
   {
      return (0);
   }

	//Print("slBuyFactor ", slInit, " ", slMax, " ", AccountFreeMargin(), " ", riskCapital, " result ", slBuyFactor);      
	bool gotRecommendation = false;

	int spread = 3;
	int    digits=MarketInfo(Symbol(), MODE_DIGITS);
	int lockreturn = MyLock("Predictor");

	if(lockreturn != LOCK_SUCCESS)
	{
		LockErrorHandler(lockreturn);
		return (lockreturn);
	}

	if(! IsTesting())
	{
		Print("Got bar and start execution: "+ TimeToStr(Time[0]) + " Open[0]: "+Open[0]+" Low[0]: "+Low[0]+" High[0]: "+High[0]+" Close[0]: "+Close[0]);
	}

	{
		RefreshRates();
		spread = MarketInfo(Symbol(), MODE_SPREAD);
	} 


	int total = OrdersTotal();   

	// count orders for current symbol
	int symbolOrders = 0;
	for(i = total - 1; i >= 0; i--) 
	{
		OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
		// check for symbol & magic number
		if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
		{
			symbolOrders=symbolOrders+1;
		}
	}

	bool nextChartPeriod = false;
	if(iTime(Symbol(),Period(),0) != prevChartPeriod)
	{
		prevChartPeriod = iTime(Symbol(),Period(),0);
		nextChartPeriod = true;

	}

	// Close all orders at the end of week   
	if((nextChartPeriod) && ((TimeDayOfWeek(prevtime) > denZakryttiaOrderiv) || 
		((TimeDayOfWeek(prevtime) == denZakryttiaOrderiv) && (TimeHour(prevtime) >= hodynaZakryttiaOrderiv))))
	{
		if(symbolOrders > 0)
		{
			Print("Close all orders for holidays");
		}
		Print("Symbol: "+Symbol());

		// close all open orders
		for(i = total - 1; i >= 0; i--) 
		{
			OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
			if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
			{

				prevticket = OrderTicket();

				Print("Closing with profit: "+ OrderProfit( ));
				// calculate mean SR
				if(OrderProfit( ) > 0)
				{
					meanSR = meanSR + (lastSR-meanSR)/(numSR+1);
					numSR = numSR + 1;
					Print("MeanSR: "+meanSR + " num.profitable orders: " + numSR + " lastSR: " + lastSR);
				}
				else
				{
				}
				ClosePosBySelect();
			}
		}
		lockreturn = MyUnlock("Predictor");

		if(lockreturn != LOCK_SUCCESS)
		{
			LockErrorHandler(lockreturn);
		}             
		return (lockreturn);
	}


	// there are open orders
	if(symbolOrders > 0)
	{
		recommendation();
		gotRecommendation = true;   
	}

	int ticket = -1;

	double stopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;   

	if(gainCapital == 0)
	{
		//Print("Define some gain capital for take profit calculation");
		takeProfitBuy = 0;
		takeProfitSell = 0;
	}

	if(gainCapital != 0)
	{
		takeProfitBuy=TakeProfitSize(OP_BUY, lots, Open[0], gainCapital);

		if((takeProfitBuy < stopLevel))
		{
			takeProfitBuy = stopLevel;
		}
	}

	if(gainCapital != 0)
	{
		takeProfitSell=TakeProfitSize(OP_SELL, lots, Open[0], gainCapital);

		if((takeProfitSell < stopLevel))
		{
			takeProfitSell = stopLevel;
		}      

	}
	// perevirka rozvorotu    
	{
		for(i = total - 1; i >= 0; i--) 
		{
			OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
			// check for symbol & magic number
			if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
			{
				prevticket = OrderTicket();
				// long position is opened
				if(OrderType() == OP_BUY) 
				{
					if((longRecommendation == 3) && (shortRecommendation == 3)) 
					{                     
					}
					else if((longRecommendation == -3) && (shortRecommendation == -3)) 
					{ // reverse

						if(takeProfitSell == 0)
						{
							tpVal = 0;
						}
						else
						{
							tpVal = Open[0] -takeProfitSell;
						}

						slSell = StopLossSize(OP_SELL, lots, Open[0], riskCapital);

						if(slSell == 0)
						{
							slVal = 0;
						}
						else
						{
							slVal = Open[0] + slSell;
						}

						ticket = OpenPosition(Symbol(), OP_SELL, OrderLots() + lots, 
							slVal, tpVal, MagicNumber, Red); 
						Sleep(30000);
						//----
						if(ticket < 0) 
							prevtime = Time[1];
						else 
							PositionCloseBy(prevticket, ticket, Blue);   
					} 
					else
					{
						ClosePosBySelect();
					}
				} 
				else // if(OrderType() == OP_SELL) 
				{
					if((longRecommendation == -3) && (shortRecommendation == -3)) 
					{
						// do nothing, leave order open 
					}
					else if((longRecommendation== 3) && (shortRecommendation == 3)) 
					{ // reverse
						
						if(takeProfitBuy == 0)
						{
							tpVal = 0;
						}
						else
						{
							tpVal = Open[0] + takeProfitBuy;
						}

						slBuy = StopLossSize(OP_BUY, lots, Open[0], riskCapital);

						if(slBuy == 0)
						{
							slVal = 0;
						}
						else
						{
							slVal = Open[0] - slBuy;
						}
						ticket = OpenPosition(Symbol(), OP_BUY, OrderLots() + lots, 
							slVal, tpVal, MagicNumber, Blue); 

						Sleep(30000);
						//----
						if(ticket < 0) 
							prevtime = Time[1];
						else 
							PositionCloseBy(prevticket, ticket, Blue);   
					} 
					else
					{
						ClosePosBySelect();
					}
				}
				// exit
				lockreturn = MyUnlock("Predictor");

				if(lockreturn != LOCK_SUCCESS)
				{
					LockErrorHandler(lockreturn);
				}             
				return (lockreturn);

			}
		}
	}

	if((symbolOrders == 0) && (nextChartPeriod == true))
	{      
		bool startOk = (TimeDayOfWeek(prevtime) > denVidkryttiaOrderivP) || ((TimeDayOfWeek(prevtime) == denVidkryttiaOrderivP)&& (TimeHour(prevtime) >= hodynaVidkryttiaOrderivP));  

		bool endOk = (TimeDayOfWeek(prevtime) < denVidkryttiaOrderivK) || ((TimeDayOfWeek(prevtime) == denVidkryttiaOrderivK)&& (TimeHour(prevtime) <= hodynaVidkryttiaOrderivK));  

		if(!startOk || !endOk)
		{
			return (0);
		}
		if(!gotRecommendation)
		{
			recommendation();
		}

		// check for long or short position possibility
		if((longRecommendation == 3) && (shortRecommendation == 3)) 
		{ //long
		
			if(takeProfitBuy == 0)
			{
				tpVal = 0;
			}
			else
			{
				tpVal = Open[0] + takeProfitBuy;
			}

			slBuy = StopLossSize(OrderType(), lots, Open[0], riskCapital);
			if(slBuy == 0)
			{
				slVal = 0;
			}
			else
			{
				slVal = Open[0] - slBuy;
			}

			ticket = OpenPosition(Symbol(), OP_BUY, lots, slVal, tpVal, MagicNumber, Blue); 

			if(ticket < 0) 
			{
				Sleep(30000);
				prevtime = Time[1];
			}
		} 
		else  if((longRecommendation == -3) && (shortRecommendation == -3)) 
		{ // short
			
			if(takeProfitSell == 0)
			{
				tpVal = 0;
			}
			else
			{	
				tpVal = Open[0]-takeProfitSell;
			}

			slSell = StopLossSize(OrderType(), lots, Open[0], riskCapital);

			if(slSell == 0)
			{
				slVal = 0;
			}
			else
			{
				slVal = Open[0] + slSell;
			}

			ticket = OpenPosition(Symbol(), OP_SELL, lots, 
				slVal, tpVal, MagicNumber, Red); 

			if(ticket < 0) 
			{
				Sleep(30000);
				prevtime = Time[1];
			}
		}
	}
	lockreturn = MyUnlock("Predictor");

	if(lockreturn != LOCK_SUCCESS)
	{
		LockErrorHandler(lockreturn);
	}             
	return (lockreturn);
}

void recommendation()
{
	double sRecommendation = 0;
	double lRecommendation = 0;
	double recommendation = 0;

	if(! IsTesting())
	{   
		Print("Getting recommendation for " + Symbol());
	}   


   lRecommendation = PrepareRecommendation(0,
	   periodTrendExtractionL,
	   periodTrendPredictionL,
	   numberTrainingRowsL,
	   displacementL,
	   discretizationIntervalL,
	   amplitudeMethodL,
	   cmL);                    

	longRecommendation = lRecommendation; 

   if(MathAbs(longRecommendation) != 3)
   {
      Print("Long period of WAIT");		
      return;  
   }	
	sRecommendation = PrepareRecommendation(sPeriod,
		periodTrendExtractionS,
		periodTrendPredictionS,
		numberTrainingRowsS,
		displacementS,
		discretizationIntervalS,
		amplitudeMethodS,
		cmS);                    

	shortRecommendation = sRecommendation;

	//if(!IsTesting())
	{
		string sRecString = "WAIT";
		string lRecString = "WAIT";
		if(sRecommendation == 3)
		{
			sRecString = "BUY";            
		}
		else if(sRecommendation == -3)
		{
			sRecString = "SELL";            
		}  

		if(lRecommendation > 1)
		{
			lRecString = "BUY";            
		}
		else if(lRecommendation < -1)
		{
			lRecString = "SELL";            
		}  
		Print("Short period of " + sRecString +  ", Long period of " + lRecString);
	}
	
	if(( MathAbs(longRecommendation) == 3) && (MathAbs(shortRecommendation) == 3))
	{
		lots = multiplicator*lotsInit;      
	}
	else
	{
		lots = lotsInit;
	}
}

double PrepareRecommendation(int timeframe,
							 int periodTrendExtraction,
							 int periodTrendPrediction,
							 int numberTrainingRows,
							 int displacement,
							 int discretizationInterval,
							 int amplitudeMethod,
							 double cm)
{
	double trendDirections[2][1];   
	double rates[][6];   

	int numberPrincipalComponents = periodTrendPrediction;
	int numberRates = ArrayCopyRates(rates, Symbol(), timeframe);
	int error=GetLastError();
	if(error==4066)
	{
		for(int i=0;i<5; i++)
		{
			Sleep(5000);
			numberRates = ArrayCopyRates(rates, Symbol(), timeframe);
			error=GetLastError();

			if(error!=4066) break;
		}
	}

	ErrorHandler();

	if(numberRates < (numberTrainingRows+periodTrendExtraction+1))
	{
		Alert("Need " + (periodTrendExtraction+numberTrainingRows+1) + " bars. Got only "+ numberRates);
		return (0);
	}

	double rec = WAIT;
	rec = Predictor(rates, numberRates,
		periodTrendExtraction,
		periodTrendPrediction,
		numberPrincipalComponents,
		numberTrainingRows,
		displacement,
		discretizationInterval,
		amplitudeMethod,
		cm);                    
	lots = lotsInit;

	return (rec);																					
}


